#include <sharedm.h>
#include <iostream.h>
#define CC //

void	*SharedMemArena::arena = (void *)1;
usptr_t *SharedMemArena::Arena = (void *)1;
char	*SharedMemArena::adres ;	
char	*SharedMemArena::name  = "/usr/tmp/SharedMemArena" ;
int	 SharedMemArena::did_it= 0;
int	 SharedMemArena::size= 0;
int	 SharedMemArena::flag= 0;
long	 memalloced = 0;
//const char   IS_SHARED	= 's' ;
//const char   NOT_SHARED	= 'm' ;

// ---------------------------------------------------------------------------
//		    new && delete 
// ---------------------------------------------------------------------------
// --- anonymous delete and new 
// --- add a note about origin of mem .
// ---------------------------------------------------------------------------

void *operator new ( size_t size   )
{
//    static char *state[2] = { "normal", "shared" };
    void *addr =0x0;
    size_t totsize = size ;
//--    fprintf(stderr ," Allocating from %s memory \n ", state[SharedMemArena::flag]); 
//--    fprintf(stderr ," size  : %d " , totsize ); 
//--    fflush(stderr);
   
    addr = (void *)SharedMemArena::malloc( totsize );
	 
   
//--    fprintf( stderr ,  " malloc from normal mem : base addr : %lx \n" , addr ); 
//--    fprintf( stderr ,  " ----------------------------- \n "  ); 
//--    fflush(stderr);
    return addr ;
}
// ---------------------------------------------------------------------------
void operator delete ( void *p ) 
{
//    static char *state[2] = { "normal", "shared" };
//--   fprintf(stderr ," deleting from %s memory %lx \n ", state[SharedMemArena::flag], p); 
//--   fflush(stderr);
   
    SharedMemArena::free(p);
   
}
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
//		    shared code 
// ---------------------------------------------------------------------------
// --- constructor 
SharedMemArena::SharedMemArena()
{
    if( did_it )
    {
	perror( " second instance of SharedMemArena " );
    }
}
// --- do anything only once 
SharedMemArena::SharedMemArena( size_t sz )
{
    if( !did_it ){
	init(sz);
	did_it = 1;
	size = sz ;
    }else
	perror ( " second instance of SharedMemArena " );
}
// --- constructor 
// --- for using someone elses's arena allocator.
// --- the cave has an arena allocator so 
// --- void *CAVEUserSharedMemory(int size) 
// --- SharedMemArena mem(  CAVEUserSharedMemory, megs(50));
// --- will do the job.
SharedMemArena::SharedMemArena(void *(*arenamaker)(int), size_t sz )
{
    if( did_it ) 
    {
	perror( " gonna blow away already allocated arena  " );
	adelete( SharedMemArena::arena );
    }
    size = sz ;
    SharedMemArena::arena = arenamaker(size);
}
// --- constructor 
// --- if you already have an arena pass it to me 
// ---
void SharedMemArena::load_arena( void *ar, int sz )
{
    if(did_it)
    {
	perror( " gonna blow away already allocated arena  " );
	adelete( SharedMemArena::arena );
    }
    SharedMemArena::arena = ar ;
    SharedMemArena::size = sz ;
}
// --- destructor  
SharedMemArena::~SharedMemArena()
{
    adelete( SharedMemArena::arena );
//   cout << " arena destructor : " << endl;
}


// --- 
// --- initialization routine ( lifted from j.goldman via carolina.niera.cruz )
// --- 
void SharedMemArena::init( size_t sz )
{
    char *	shmemFile = "/dev/zero";   
    int        shmemFd;
    void        *_shmemArena, *shmemAddr;

    if((shmemFd = open(shmemFile, O_RDWR|O_CREAT)) < 0)
    {
        perror("open");
        SharedMemArena::arena =  NULL;
    }

#ifndef MAP_AUTORESV
#define MAP_AUTORESV 0x100
#endif
    if((int)(shmemAddr = mmap(SharedMemArena::adres, sz, 
                              PROT_READ|PROT_WRITE,
                              MAP_SHARED|MAP_AUTOGROW|
                              MAP_AUTORESV, shmemFd, 0)) < 0)
    {
        perror("mmap");
        close(shmemFd);
	SharedMemArena::arena =  NULL;
    }
    
    close(shmemFd);

    if(!(Arena = usinit(SharedMemArena::name)))
    {
        perror("usinit");
        SharedMemArena::arena =  NULL;
    }
    unlink(SharedMemArena::name);
    
    if(!(_shmemArena = acreate(shmemAddr, sz, MEM_SHARED, Arena, NULL))) 
    {
        perror("acreate");
        SharedMemArena::arena =  NULL;
    }

    SharedMemArena::arena = _shmemArena;
}
// --- 
// --- memory calls are just like the c-standard calls but alloc from
// --- the shared mem area ...
// --- 
// --- malloc call 
void *
SharedMemArena::malloc( size_t t ) 
{ 
    if( SharedMemArena::flag )
	return amalloc(t , arena ) ; 
    else
	return ::malloc( t );
}
// --- free memory call 
void  
SharedMemArena::free( void *p )  
{ 
    if( SharedMemArena::flag )
	afree( p, arena ); 
    else 
	::free(p);
}

void SharedMemArena::perror( char *errormsg )
{
    fprintf(stderr, " sharedmem : % s \n",  errormsg );
}
